class com.neodelight.v2D.Gun
{
   var owner;
   var mc;
   var config;
   var id;
   var canvas;
   var offset;
   var dir;
   var multi;
   var paral;
   var dirRandom;
   var globalPos;
   var reloadTime;
   var ammo;
   var snd;
   var accThrow;
   var maxBullets;
   var actBullets;
   var shootFromOffscreen;
   var reloadStat;
   var ready;
   function Gun(owner, config)
   {
      this.owner = owner;
      this.mc = this.owner.mc;
      this.config = config;
      this.id = "gun@" + this.owner.id;
      this.canvas = com.neodelight.std.Canvas.getCanvasById("shots");
      this.offset = new com.neodelight.std.Vector(com.neodelight.std.XMath.toNumber(this.config.gunOffsetX),com.neodelight.std.XMath.toNumber(this.config.gunOffsetY),0);
      this.dir = com.neodelight.std.XMath.toNumber(this.config.gunDir) * 2 * 3.141592653589793;
      this.multi = !config.gunMulti ? [0] : config.gunMulti.concat();
      this.paral = !config.gunParal ? [0] : config.gunParal.concat();
      for(var _loc3_ in this.multi)
      {
         this.multi[_loc3_] *= 6.283185307179586;
         this.paral[_loc3_] = com.neodelight.std.XMath.toNumber(this.paral[_loc3_]);
      }
      this.dirRandom = com.neodelight.std.XMath.toNumber(config.gunDirRandom);
      this.globalPos = new com.neodelight.std.Vector(0,0);
      this.reloadTime = com.neodelight.std.XMath.toNumber(this.config.gunReloadTime);
      this.ammo = com.neodelight.std.Blueprint.getBlueprint(this.config.gunAmmo);
      if(this.config.sound)
      {
         this.snd = new com.neodelight.v2D.V2DSound(this,this.config);
      }
      trace("new Gun()> " + this.id + " config: " + com.neodelight.std.XString.dump(this.config) + " snd: " + this.snd);
      if(this.ammo.explosion)
      {
         this.ammo.explosion = com.neodelight.std.Blueprint.getBlueprint(this.ammo.explosion);
      }
      this.accThrow = !this.config.gunAccThrow ? new com.neodelight.std.Vector(0,0) : this.config.gunAccThrow;
      this.maxBullets = !this.config.gunMaxBullets ? 0 : com.neodelight.std.XMath.toNumber(this.config.gunMaxBullets);
      this.actBullets = 0;
      this.shootFromOffscreen = false;
      this.reset();
   }
   function reset()
   {
      this.reloadStat = 0;
      this.ready = true;
   }
   function move()
   {
      this.reloadStat = Math.max(0,this.reloadStat - _global.dt);
      this.ready = this.reloadStat == 0;
   }
   function aim(dir)
   {
   }
   function shoot()
   {
      if(this.owner.gunsoff)
      {
         return false;
      }
      if(this.reloadStat == 0 && (this.actBullets >= 1 || this.maxBullets == 0))
      {
         if(!this.shootFromOffscreen)
         {
            this.globalPos.x = this.owner.pos.x;
            this.globalPos.y = this.owner.pos.y;
            _global.world.levelMc.localToGlobal(this.globalPos);
            if(this.globalPos.x + this.owner.size.x < 0 || this.globalPos.x > _global.game.stageWidth || this.globalPos.y + this.owner.size.y < 0 || this.globalPos.y > _global.game.stageHeight)
            {
               return undefined;
            }
         }
         if(this.snd)
         {
            trace("Gun: trigger shoot sound");
            this.snd.playEvent("Shoot");
         }
         else
         {
            trace("Gun: no sound");
         }
         this.actBullets = Math.max(0,this.actBullets - 1);
         this.reloadStat = this.reloadTime;
         this.ready = this.reloadStat == 0;
         var _loc4_ = 0;
         while(_loc4_ < this.multi.length)
         {
            var _loc3_ = this.canvas.attachMovie(this.ammo.libId);
            if(this.owner.renderRotation)
            {
               _loc3_._x = this.owner.pos.x + this.owner.size.x * 0.5 - (this.offset.y + this.paral[_loc4_]) * Math.sin(this.owner.pos.z) + this.offset.x * Math.cos(this.owner.pos.z);
               _loc3_._y = this.owner.pos.y + this.owner.size.y * 0.5 + (this.offset.y + this.paral[_loc4_]) * Math.cos(this.owner.pos.z) + this.offset.x * Math.sin(this.owner.pos.z);
            }
            else
            {
               _loc3_._x = this.owner.pos.x + this.owner.size.x * 0.5 + this.offset.x * this.owner.lookDir;
               _loc3_._y = this.owner.pos.y + this.owner.size.y * 0.5 + this.offset.y + this.paral[_loc4_];
            }
            var _loc5_ = this.dir + this.multi[_loc4_] + (Math.random() - 0.5) * this.dirRandom;
            _loc5_ += this.owner.pos.z;
            _loc3_.moverVx = this.owner.v.x * this.accThrow.x + this.ammo.moverV * Math.sin(_loc5_) * this.owner.lookDir;
            _loc3_.moverVy = this.owner.v.y * this.accThrow.y + this.ammo.moverV * (- Math.cos(_loc5_));
            _loc3_.owner = this.owner;
            com.neodelight.std.Blueprint.apply(_loc3_,this.config.gunAmmo);
            if(_loc3_.behaviour == "PointSprite")
            {
               if(_loc3_.gfx)
               {
                  _loc3_.gfx._rotation = com.neodelight.std.XMath.vAngle(_loc3_.moverVx,_loc3_.moverVy) / 3.141592653589793 * 180;
               }
               else
               {
                  _loc3_._rotation = com.neodelight.std.XMath.vAngle(_loc3_.moverVx,_loc3_.moverVy) / 3.141592653589793 * 180;
               }
            }
            else
            {
               _loc3_._x -= _loc3_._width * 0.5;
               _loc3_._y -= _loc3_._height * 0.5;
            }
            var _loc6_ = com.neodelight.std.ClassLib.getClass(this.ammo.behaviour);
            var _loc7_ = new _loc6_(_loc3_,this.ammo.friction,this.ammo.weight,0,String(this.config.gunShotGroupsCol).split(","));
            _loc7_.pos.z = com.neodelight.std.XMath.vAngle(_loc3_.moverVx,_loc3_.moverVy);
            _loc4_ = _loc4_ + 1;
         }
         return true;
      }
      return false;
   }
}
