class com.neodelight.v2D.MoverCircle extends com.neodelight.v2D.Mover
{
   var rotV;
   var startPos;
   var radius;
   var rotPos;
   var pos;
   var origin;
   var active;
   var v;
   var client;
   function MoverCircle(client, config)
   {
      super(client);
      this.rotV = com.neodelight.std.XMath.toNumber(config.moverV) / (6.283185307179586 * com.neodelight.std.XMath.toNumber(config.moverRadius));
      this.startPos = com.neodelight.std.XMath.toNumber(config.moverStartPos);
      this.radius = com.neodelight.std.XMath.toNumber(config.moverRadius);
      this.reset();
   }
   function reset()
   {
      super.reset();
      this.rotPos = this.startPos;
      this.pos.x = this.origin.x + Math.cos(this.rotPos * 2 * 3.141592653589793) * this.radius;
      this.pos.y = this.origin.y + Math.sin(this.rotPos * 2 * 3.141592653589793) * this.radius;
   }
   function move()
   {
      if(!this.active)
      {
         return undefined;
      }
      super.move();
      this.rotPos = (this.rotPos + 1 + this.rotV) % 1;
      this.v.x = this.origin.x + Math.cos(this.rotPos * 2 * 3.141592653589793) * this.radius - this.pos.x;
      this.v.y = this.origin.y + Math.sin(this.rotPos * 2 * 3.141592653589793) * this.radius - this.pos.y;
   }
   function getTotalBoundingRect()
   {
      this.client.totalBoundingRect.p0.x = this.origin.x - this.radius;
      this.client.totalBoundingRect.p0.y = this.origin.y - this.radius;
      this.client.totalBoundingRect.p1.x = this.origin.x + this.radius;
      this.client.totalBoundingRect.p1.y = this.origin.y + this.radius;
      return this.client.totalBoundingRect;
   }
}
