class com.neodelight.v2D.MoverExistInterval extends com.neodelight.v2D.Mover
{
   var timeOn;
   var timeOff;
   var startStatus;
   var client;
   var actStatus;
   var mc;
   var sleep;
   var active;
   var origin;
   function MoverExistInterval(client, config)
   {
      super(client);
      this.timeOn = com.neodelight.std.XMath.toNumber(config.moverTimeOn);
      this.timeOff = com.neodelight.std.XMath.toNumber(config.moverTimeOff);
      this.startStatus = Boolean(config.moverStartStatus);
      this.client.inactiveMove = true;
      this.reset();
   }
   function reset()
   {
      super.reset();
      this.actStatus = this.startStatus;
      this.mc._visible = false;
      if(this.actStatus)
      {
         this.sleep = this.timeOn;
      }
      else
      {
         this.sleep = this.timeOff;
      }
      this.mc._visible = this.actStatus;
   }
   function move()
   {
      if(!this.active)
      {
         return undefined;
      }
      super.move();
      this.mc._visible = this.actStatus;
      this.client.inactive = !this.actStatus;
      if(this.sleep)
      {
         this.sleep = Math.max(0,this.sleep - _global.dt);
      }
      else
      {
         this.actStatus = !this.actStatus;
         if(this.actStatus)
         {
            if(this.timeOn > 0)
            {
               this.sleep = this.timeOn - 1;
            }
            else
            {
               this.actStatus = !this.actStatus;
            }
         }
         else if(this.timeOff > 0)
         {
            this.sleep = this.timeOff - 1;
         }
         else
         {
            this.actStatus = !this.actStatus;
         }
      }
   }
   function getTotalBoundingRect()
   {
      this.client.totalBoundingRect.p0.x = this.origin.x;
      this.client.totalBoundingRect.p0.y = this.origin.y;
      this.client.totalBoundingRect.p1.x = this.origin.x;
      this.client.totalBoundingRect.p1.y = this.origin.y;
      this.client.totalBoundingRect.standardize();
      return this.client.totalBoundingRect;
   }
}
