class com.neodelight.v2D.MoverFloat extends com.neodelight.v2D.Mover
{
   var destination;
   var origin;
   var moverOrigin;
   var vDown;
   var vUp;
   var vHorizontal;
   var dir;
   var destinationPause;
   var sineSeed;
   var sineFrequ;
   var sineAmp;
   var flagSkip;
   var startPos;
   var pos;
   var sleep;
   var active;
   var v;
   var client;
   function MoverFloat(client, config)
   {
      super(client);
      this.destination = new com.neodelight.std.Vector3D(this.origin.x + int(config.moverDx),this.origin.y + int(config.moverDy),0);
      this.moverOrigin = new com.neodelight.std.Vector3D(this.origin.x,this.origin.y,0);
      this.vDown = Math.min(1,Math.max(0,com.neodelight.std.XMath.toNumber(config.moverVDown)));
      this.vUp = Math.min(1,Math.max(0,com.neodelight.std.XMath.toNumber(config.moverVUp)));
      this.vHorizontal = Number(config.moverV);
      this.dir = 1;
      this.destinationPause = com.neodelight.std.XMath.toNumber(config.moverDestinationPause);
      this.sineSeed = Math.random() * 10000;
      this.sineFrequ = Math.min(1,Math.max(0,com.neodelight.std.XMath.toNumber(config.moverSineFrequ)));
      this.sineAmp = Math.min(1,Math.max(0,com.neodelight.std.XMath.toNumber(config.moverSineAmp)));
      this.flagSkip = Boolean(config.moverSkip);
      this.startPos = com.neodelight.std.XMath.toNumber(config.moverStartPos);
      this.reset();
   }
   function reset()
   {
      super.reset();
      this.pos.x = this.origin.x + this.startPos * (this.destination.x - this.pos.x);
      this.pos.y = this.origin.y;
      this.sleep = 0;
   }
   function move()
   {
      if(!this.active)
      {
         this.v.x = 0;
         this.v.y = 0;
         return undefined;
      }
      super.move();
      var _loc4_ = undefined;
      if(this.sleep)
      {
         this.sleep = Math.max(0,this.sleep - _global.dt);
         this.v.x = 0;
         this.v.y = 0;
      }
      else
      {
         this.v.x = this.destination.x - this.pos.x;
         _loc4_ = Math.max(0,Math.min(1,this.vHorizontal / Math.abs(this.v.x)));
         if(!isFinite(_loc4_))
         {
            _loc4_ = 0;
         }
         if(_loc4_ == 1)
         {
            this.sleep = this.destinationPause;
            if(this.flagSkip)
            {
               this.pos.x = this.origin.x;
            }
            else
            {
               var _loc7_ = this.destination.x;
               this.destination.x = this.moverOrigin.x;
               this.moverOrigin.x = _loc7_;
            }
         }
         this.v.x *= _loc4_;
      }
      var _loc5_ = 0;
      for(var _loc6_ in this.client.cargo)
      {
         _loc5_ += this.client.cargo[_loc6_].weight;
      }
      if(_loc5_ > 0)
      {
         this.v.y = this.destination.y - this.pos.y;
         _loc4_ = this.vDown;
      }
      else
      {
         var _loc8_ = (Math.sin(getTimer() * this.sineFrequ + this.sineSeed) * 0.5 + 0.5) * this.sineAmp * (this.destination.y - this.origin.y);
         this.v.y = this.origin.y + _loc8_ - this.pos.y;
         _loc4_ = this.vUp;
      }
      this.v.y *= _loc4_;
   }
   function getTotalBoundingRect()
   {
      this.client.totalBoundingRect.p0.x = this.origin.x;
      this.client.totalBoundingRect.p0.y = this.origin.y;
      this.client.totalBoundingRect.p1.x = this.destination.x;
      this.client.totalBoundingRect.p1.y = this.destination.y;
      this.client.totalBoundingRect.standardize();
      return this.client.totalBoundingRect;
   }
}
