class com.neodelight.v2D.MoverTargeter extends com.neodelight.v2D.Mover
{
   var destination;
   var pos;
   var dir;
   var speed;
   var acc;
   var angleForbiddenFrom;
   var angleForbiddenTo;
   var targetObjectId;
   var startPos;
   var origin;
   var active;
   var v;
   var size;
   var client;
   function MoverTargeter(client, config)
   {
      super(client);
      this.destination = new com.neodelight.std.Vector3D(this.pos.x,this.pos.y,0);
      this.dir = 1;
      this.speed = com.neodelight.std.XMath.toNumber(config.moverV);
      this.acc = com.neodelight.std.XMath.toNumber(config.moverA);
      this.angleForbiddenFrom = com.neodelight.std.XMath.toNumber(config.moverAngleForbiddenFrom) * 2 * 3.141592653589793;
      this.angleForbiddenTo = com.neodelight.std.XMath.toNumber(config.moverAngleForbiddenTo) * 2 * 3.141592653589793;
      this.targetObjectId = "player";
      this.startPos = com.neodelight.std.XMath.toNumber(config.moverStartPos) * 2 * 3.141592653589793;
      this.destination.z = this.startPos;
      this.reset();
   }
   function reset()
   {
      super.reset();
      this.pos.x = this.origin.x;
      this.pos.y = this.origin.y;
      this.pos.z = this.startPos;
      if(this.angleForbiddenFrom > this.angleForbiddenTo && (this.pos.z < this.angleForbiddenTo || this.pos.z > this.angleForbiddenFrom) || this.angleForbiddenFrom < this.angleForbiddenTo && (this.pos.z < this.angleForbiddenTo && this.pos.z > this.angleForbiddenFrom))
      {
         this.pos.z = this.angleForbiddenFrom;
      }
   }
   function move()
   {
      if(!this.active)
      {
         this.v.z = 0;
         return undefined;
      }
      var _loc6_ = _global.world.levelMc[this.targetObjectId].engine;
      if(Math.abs(_loc6_.pos.x - (this.pos.x + this.size.x * 0.5)) > _global.game.stageWidth || Math.abs(_loc6_.pos.y - (this.pos.y + this.size.y * 0.5)) > _global.game.stageHeight)
      {
         this.v.z = 0;
         return undefined;
      }
      if(!_loc6_)
      {
         trace("##ERROR: MoverTargeter.move(): target \'" + this.targetObjectId + "\' not found!");
      }
      else
      {
         var _loc5_ = com.neodelight.std.XMath.vAngle(_loc6_.pos.x + _loc6_.size.x * 0.5 - this.pos.x,_loc6_.pos.y + _loc6_.size.y * 0.5 - this.pos.y);
         var _loc4_ = com.neodelight.std.XMath.angleDiff(this.pos.z,_loc5_);
         if(this.angleForbiddenFrom > this.angleForbiddenTo && (this.pos.z < this.angleForbiddenTo || this.pos.z > this.angleForbiddenFrom) || this.angleForbiddenFrom < this.angleForbiddenTo && (this.pos.z < this.angleForbiddenTo && this.pos.z > this.angleForbiddenFrom))
         {
            var _loc8_ = com.neodelight.std.XMath.angleDiff(this.pos.z,this.angleForbiddenTo);
            var _loc7_ = com.neodelight.std.XMath.angleDiff(this.pos.z,this.angleForbiddenFrom);
            if(Math.abs(_loc8_) < Math.abs(_loc7_))
            {
               _loc4_ = _loc8_;
            }
            else
            {
               _loc4_ = _loc7_;
            }
         }
         else if(this.angleForbiddenFrom > this.angleForbiddenTo && (_loc5_ < this.angleForbiddenTo || _loc5_ > this.angleForbiddenFrom) || this.angleForbiddenFrom < this.angleForbiddenTo && (_loc5_ < this.angleForbiddenTo && _loc5_ > this.angleForbiddenFrom))
         {
            _loc8_ = com.neodelight.std.XMath.angleDiff(_loc5_,this.angleForbiddenTo);
            _loc7_ = com.neodelight.std.XMath.angleDiff(_loc5_,this.angleForbiddenFrom);
            if(Math.abs(_loc8_) < Math.abs(_loc7_))
            {
               _loc4_ = com.neodelight.std.XMath.angleDiff(this.pos.z,this.angleForbiddenTo);
            }
            else
            {
               _loc4_ = com.neodelight.std.XMath.angleDiff(this.pos.z,this.angleForbiddenFrom);
            }
         }
         if(_loc4_ > 0)
         {
            this.v.z = Math.min(this.speed,this.v.z + Math.min(_loc4_,this.acc));
         }
         else
         {
            this.v.z = Math.max(- this.speed,this.v.z + Math.max(_loc4_,- this.acc));
         }
      }
      super.move();
   }
   function getTotalBoundingRect()
   {
      this.client.totalBoundingRect.p0.x = this.origin.x;
      this.client.totalBoundingRect.p0.y = this.origin.y;
      this.client.totalBoundingRect.p1.x = this.origin.x;
      this.client.totalBoundingRect.p1.y = this.origin.y;
      this.client.totalBoundingRect.standardize();
      return this.client.totalBoundingRect;
   }
}
