class com.neodelight.v2D.Sprite extends com.neodelight.v2D.V2DObject
{
   var origin;
   var pos;
   var a;
   var config;
   var f;
   var v;
   var vMax;
   var tpos;
   var tv;
   var tvxy;
   var lookDir;
   var renderLookDir;
   var renderAutoRotate;
   var renderRotation;
   var weight;
   var mc;
   var flex;
   var cargo;
   var slaves;
   var master;
   var collisionPartners;
   var colGhosts;
   var mover;
   var guns;
   var chain;
   var engine;
   var actDeathCount;
   var inactive;
   var inactiveMove;
   var colNewVr;
   var colPos;
   var colType;
   var colNewVx;
   var colNewVy;
   var colNewPartnerVx;
   var colPartner;
   var colNewPartnerVy;
   var events;
   var animMgrStep;
   var animMgr;
   var freeMovement;
   var groups;
   var totalBoundingRect;
   var size;
   var isPlayer = false;
   static var gravity = 0;
   function Sprite(mc, f, weight, flags, collisionPartners, moverId)
   {
      super(mc,flags);
      this.origin = new com.neodelight.std.Vector3D(this.pos.x,this.pos.y,this.pos.z);
      this.a = !this.config.accelleration ? new com.neodelight.std.Vector3D(0,0,0) : this.config.accelleration;
      this.f = !this.config.friction ? new com.neodelight.std.Vector3D(0,0,0) : this.config.friction;
      this.v = new com.neodelight.std.Vector3D(0,0,0);
      this.vMax = new com.neodelight.std.Vector3D(0,0,0);
      this.tpos = new com.neodelight.std.Vector3D(0,0,0);
      this.tv = new com.neodelight.std.Vector3D(0,0,0);
      this.tvxy = 0;
      this.lookDir = 1;
      this.renderLookDir = Boolean(mc.flagRenderLookDir);
      this.renderAutoRotate = Boolean(mc.flagRenderAutoRotate);
      this.renderRotation = Boolean(mc.flagRenderRotation);
      this.weight = com.neodelight.std.XMath.toNumber(this.mc.weight);
      this.flex = com.neodelight.std.XMath.toNumber(this.mc.flex);
      this.cargo = new Array();
      if(mc.linkSlaves)
      {
         this.slaves = this.mc.linkSlaves.split(",");
         for(var _loc8_ in this.slaves)
         {
            this.slaves[_loc8_] = _global.world.levelMc[this.slaves[_loc8_]];
         }
      }
      if(mc.linkMaster)
      {
         this.master = _global.world.levelMc[this.mc.linkMaster];
      }
      if(this.mc.groupsCol == undefined)
      {
         this.mc.groupsCol = "";
      }
      this.collisionPartners = collisionPartners eq "undefined" ? (!this.mc.groupsCol ? undefined : this.mc.groupsCol.split(",")) : collisionPartners;
      this.colGhosts = new Array();
      if(!moverId && mc.mover)
      {
         moverId = mc.mover;
      }
      if(moverId)
      {
         var _loc4_ = com.neodelight.std.ClassLib.getClass("Mover" + moverId);
         if(_loc4_)
         {
            this.mover = new _loc4_(this,this.mc);
         }
         else
         {
            trace("##ERROR: unknown mover: Mover" + moverId);
         }
         this.mover.getTotalBoundingRect();
      }
      if(mc.guns)
      {
         this.guns = new Array();
         var _loc7_ = mc.guns.split(",");
         var _loc8_ = 0;
         while(_loc8_ < _loc7_.length)
         {
            var _loc5_ = com.neodelight.std.Blueprint.getBlueprint(_loc7_[_loc8_]);
            _loc4_ = com.neodelight.std.ClassLib.getClass(_loc5_.gunClass);
            if(_loc4_)
            {
               this.guns.push(new _loc4_(this,_loc5_));
            }
            _loc8_ = _loc8_ + 1;
         }
      }
      if(mc.chainMc)
      {
         this.chain = new com.neodelight.v2D.Chain(mc);
      }
      if(!this.master)
      {
         if(this.slaves)
         {
            this.mc.onEnterFrame = function()
            {
               if(!_global.paused)
               {
                  this.engine.move();
                  for(var _loc3_ in this.engine.slaves)
                  {
                     this.engine.slaves[_loc3_].engine.move();
                  }
               }
            };
         }
         else
         {
            this.mc.onEnterFrame = function()
            {
               if(!_global.paused)
               {
                  this.engine.move();
               }
            };
         }
      }
      this.updateTotalBoundingRect();
      if(mc.groupsReg)
      {
         _global.world.register(this,mc.groupsReg.split(","));
      }
   }
   function move()
   {
      if(this.actDeathCount)
      {
         this.actDeathCount = Math.max(0,this.actDeathCount - 1);
         if(this.actDeathCount == 0)
         {
            this.die();
            return undefined;
         }
      }
      if(this.inactive)
      {
         if(this.inactiveMove)
         {
            this.mover.move();
         }
         return undefined;
      }
      this.mover.move();
      if(this.weight != 0)
      {
         this.v.y += com.neodelight.v2D.Sprite.gravity * this.weight;
      }
      this.tv.z = this.v.z * _global.dt;
      this.tpos.z = this.pos.z + this.tv.z;
      this.colNewVr = this.v.z;
      if(this.v.x != 0 || this.v.y != 0)
      {
         this.tv.x = this.v.x * _global.dt;
         this.tv.y = this.v.y * _global.dt;
         this.tvxy = Math.sqrt(this.tv.x * this.tv.x + this.tv.y * this.tv.y);
         this.tpos.x = this.pos.x + this.tv.x;
         this.tpos.y = this.pos.y + this.tv.y;
         this.colPos = 1;
         this.colType = 0;
         this.colNewVx = this.v.x;
         this.colNewVy = this.v.y;
         if(this.collisionPartners)
         {
            var _loc6_ = _global.world.getCollisionGroups(this,this.collisionPartners,this.getBoundingRect());
            for(var _loc7_ in _loc6_)
            {
               var _loc5_ = _loc6_[_loc7_];
               this["collisionCheck" + _loc5_.collisionStyle](_loc5_);
            }
            if(this.colNewVx != undefined)
            {
               this.v.x = this.colNewVx;
            }
            if(this.colNewVy != undefined)
            {
               this.v.y = this.colNewVy;
            }
            if(this.colNewPartnerVx != undefined)
            {
               this.colPartner.v.x = this.colNewPartnerVx;
            }
            if(this.colNewPartnerVy != undefined)
            {
               this.colPartner.v.y = this.colNewPartnerVy;
            }
         }
         this.tv.x *= this.colPos;
         this.tv.y *= this.colPos;
         this.tpos.x = this.pos.x + this.tv.x;
         this.tpos.y = this.pos.y + this.tv.y;
         this.pos.x = this.tpos.x;
         this.pos.y = this.tpos.y;
         this.v.x *= Math.pow(this.f.x,_global.dt);
         this.v.y *= Math.pow(this.f.y,_global.dt);
         if(this.colType > 0 && !this.colPartner.ghost)
         {
            if(this.colPartner.events.onCollision)
            {
               this.colPartner.events.onCollision.run(this.colPartner,this);
            }
            if(this.events.onCollision)
            {
               this.events.onCollision.run(this,this.colPartner);
            }
         }
         if(this.colGhosts.length > 0)
         {
            var _loc3_ = undefined;
            while(_loc3_ = this.colGhosts.pop())
            {
               if(_loc3_.pos <= this.colPos)
               {
                  if(_loc3_.obj.events.onCollision)
                  {
                     _loc3_.obj.events.onCollision.run(_loc3_.obj,this);
                  }
                  if(this.events.onCollision)
                  {
                     this.events.onCollision.run(this,_loc3_.obj);
                  }
               }
            }
         }
      }
      else
      {
         this.tv.x = 0;
         this.tv.y = 0;
      }
      this.pos.z = this.tpos.z % 6.283185307179586;
      while(this.pos.z < 0)
      {
         this.pos.z += 6.283185307179586;
      }
      this.v.z = this.colNewVr * Math.pow(this.f.z,_global.dt);
      this.redraw();
      if(this.animMgrStep)
      {
         this.animMgr.move();
      }
      if(this.freeMovement)
      {
         for(var _loc8_ in this.groups)
         {
            _global.world.registerUpdate(this,this.groups);
            break;
         }
      }
      if(this.guns)
      {
         for(_loc8_ in this.guns)
         {
            this.guns[_loc8_].move();
         }
      }
      if(this.chain)
      {
         this.chain.move();
      }
      if(this.slaves)
      {
         for(_loc8_ in this.slaves)
         {
            var _loc4_ = this.slaves[_loc8_].engine;
            _loc4_.pos.x += this.tv.x;
            _loc4_.pos.y += this.tv.y;
            _loc4_.redraw();
         }
      }
   }
   function tryPush(v)
   {
      if(v.x == 0 && v.y == 0)
      {
         return 1;
      }
      var _loc9_ = this.v;
      this.v = v;
      this.tv.z = this.v.z;
      this.tpos.z = this.pos.z + this.tv.z;
      if(v.x != 0 || v.y != 0)
      {
         this.tv.x = this.v.x * _global.dt;
         this.tv.y = this.v.y * _global.dt;
         this.tvxy = Math.sqrt(this.tv.x * this.tv.x + this.tv.y * this.tv.y);
         this.tpos.x = this.pos.x + this.tv.x;
         this.tpos.y = this.pos.y + this.tv.y;
         this.colPos = 1;
         this.colType = 0;
         this.colNewVx = this.v.x;
         this.colNewVy = this.v.y;
         var _loc5_ = _global.world.getCollisionGroups(this,this.collisionPartners,this.getBoundingRect());
         for(var _loc6_ in _loc5_)
         {
            var _loc4_ = _loc5_[_loc6_];
            this["collisionCheck" + _loc4_.collisionStyle](_loc4_);
         }
         if(this.colNewVx != undefined)
         {
            this.v.x = this.colNewVx;
         }
         if(this.colNewVy != undefined)
         {
            this.v.y = this.colNewVy;
         }
         if(this.colNewPartnerVx != undefined)
         {
            this.colPartner.v.x = this.colNewPartnerVx;
         }
         if(this.colNewPartnerVy != undefined)
         {
            this.colPartner.v.y = this.colNewPartnerVy;
         }
         this.tpos.x = this.pos.x + this.tv.x * this.colPos;
         this.tpos.y = this.pos.y + this.tv.y * this.colPos;
         this.pos.x = this.tpos.x;
         this.pos.y = this.tpos.y;
         this.v.x *= Math.pow(this.f.x,_global.dt);
         this.v.y *= Math.pow(this.f.y,_global.dt);
         if(this.colType > 0 && !this.colPartner.ghost)
         {
            if(this.colPartner.events.onCollision)
            {
               this.colPartner.events.onCollision.run(this.colPartner,this);
            }
            if(this.events.onCollision)
            {
               this.events.onCollision.run(this,this.colPartner);
            }
         }
         var _loc3_ = undefined;
         while(_loc3_ = this.colGhosts.pop())
         {
            if(_loc3_.pos <= this.colPos)
            {
               if(_loc3_.obj.events.onCollision)
               {
                  _loc3_.obj.events.onCollision.run(_loc3_.obj,this);
               }
               if(this.events.onCollision)
               {
                  this.events.onCollision.run(this,_loc3_.obj);
               }
            }
         }
      }
      this.pos.z = this.tpos.z % 6.283185307179586;
      if(isNaN(this.pos.z))
      {
         this.pos.z = 0;
      }
      this.v.z = this.colNewVr * Math.pow(this.f.z,_global.dt);
      this.redraw();
      if(this.freeMovement)
      {
         for(var _loc7_ in this.groups)
         {
            _global.world.registerUpdate(this,this.groups);
            break;
         }
      }
      this.v = _loc9_;
      return this.colPos;
   }
   function eventPush(self, partner, args)
   {
      var _loc4_ = this.colPos;
      var _loc2_ = this.tryPush(new com.neodelight.std.Vector3D(args[0].x,args[0].y,args[0].z));
      this.colPos = _loc4_;
      return _loc2_;
   }
   function redraw()
   {
      this.mc._x = this.pos.x;
      this.mc._y = this.pos.y;
      if(this.renderAutoRotate)
      {
         this.mc.gfx._rotation = com.neodelight.std.XMath.vAngle(this.tv.x,this.tv.y) / 3.141592653589793 * 180;
      }
      else
      {
         if(this.renderLookDir)
         {
            this.mc.gfx._xscale = Math.abs(this.mc.gfx._xscale) * this.lookDir;
         }
         if(this.renderRotation)
         {
            this.mc.gfx._rotation = this.pos.z / 3.141592653589793 * 180;
         }
      }
   }
   function onCollide(obj, speed)
   {
   }
   function getTotalBoundingRect()
   {
      return this.totalBoundingRect;
   }
   function updateTotalBoundingRect()
   {
      if(!this.mover)
      {
         return undefined;
      }
      this.mover.getTotalBoundingRect();
      this.totalBoundingRect.p1.x += this.size.x;
      this.totalBoundingRect.p1.y += this.size.y;
   }
}
